> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Trigger a pre-debit notification

POST https://rest.test.zuora.com/v1/payment-gateways/pre-debit-notification
Content-Type: application/json

To support processing recurring UPI payments through Adyen Integration v2.0,
a pre-debit notification for each posted invoice must be sent to the UPI users
before collecting the recurring payments. Use this operation to send pre-debit notification requests
to the gateway for invoices that meet the requirements.
See Implement UPI on Adyen Integration v2.0 for more information.

Before using this operation, ensure the following prerequisites are met:

* Support for UPI transactions on Adyen has been enabled. This is a feature that can be requested through the Specialized Payment Connections service at an additional cost.
* Ensure the conditions for triggering pre-debit notification requests are met.

Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/payments/payment-gateways/trigger-pre-debit-notification

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a PostTriggerPreDebitNotificationRequest.

- `invoiceKey` (string, required) — The unique identifier for an invoice. It can be either a UUID such as `2c92c8955bd63cc1015bd7c151af0000`, or an invoice number such as `INV-0000001`.
- `paymentGatewayId` (string, optional) — The ID of the payment gateway used to process the payment, such as `8ad08aef83d0c3000183d4b5a2d51933`. If it is not provided, the ID of the default payment gateway is used.
- `paymentMethodId` (string, optional) — The ID of the payment method used for the payment, such as `4ad08aef83d0c30102183d4b5a2d51733`. If it is not provided, the ID of the default payment method is used.

## Response

### 200

OK

- `success` (boolean, optional) — Indicates whether the call succeeded.
- `invoiceId` (string, optional) — The ID of the invoice, for which the pre-debit notification is triggered.
- `paymentMethodId` (string, optional) — The ID of the associated payment method.
- `gatewayId` (string, optional) — The ID of the associated payment gateway.
- `gatewayType` (string, optional) — The gateway type used in this operation.
- `gatewayVersion` (string, optional) — The version number of the gateway used.
- `notificationReferenceId` (string, optional) — The value of the `shopperNotificationReference` field returned from the gateway.
- `secondNotificationReferenceId` (string, optional, nullable) — The additional second reference ID returned from the gateway.
- `thirdNotificationReferenceId` (string, optional, nullable) — The additional third reference ID returned from the gateway.
- `extraParameters` (string, optional, nullable) — The extra optional parameter returned from the gateway.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "invoiceKey": "c2289d0a8d3af0f2018d3b2b1fd00000",
  "paymentGatewayId": "80289d0a8d3af0f2018d3b1b8b800000",
  "paymentMethodId": "40289d0a8d3af0f2018d3b2b1fd00000"
}
```

**Response**

```json
{
  "success": true,
  "invoiceId": "c2289d0a8d3af0f2018d3b2b1fd00000",
  "paymentMethodId": "40289d0a8d3af0f2018d3b2b1fd00000",
  "gatewayId": "80289d0a8d3af0f2018d3b1b8b800000",
  "gatewayType": "Adyen",
  "gatewayVersion": "2",
  "notificationReferenceId": "40289d0a8d3af0f2018d3b2b1fd00000",
  "secondNotificationReferenceId": null,
  "thirdNotificationReferenceId": null,
  "extraParameters": null
}
```

**SDK Code**

```python
import requests

url = "https://rest.test.zuora.com/v1/payment-gateways/pre-debit-notification"

payload = {
    "invoiceKey": "c2289d0a8d3af0f2018d3b2b1fd00000",
    "paymentGatewayId": "80289d0a8d3af0f2018d3b1b8b800000",
    "paymentMethodId": "40289d0a8d3af0f2018d3b2b1fd00000"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://rest.test.zuora.com/v1/payment-gateways/pre-debit-notification';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"invoiceKey":"c2289d0a8d3af0f2018d3b2b1fd00000","paymentGatewayId":"80289d0a8d3af0f2018d3b1b8b800000","paymentMethodId":"40289d0a8d3af0f2018d3b2b1fd00000"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/payment-gateways/pre-debit-notification"

	payload := strings.NewReader("{\n  \"invoiceKey\": \"c2289d0a8d3af0f2018d3b2b1fd00000\",\n  \"paymentGatewayId\": \"80289d0a8d3af0f2018d3b1b8b800000\",\n  \"paymentMethodId\": \"40289d0a8d3af0f2018d3b2b1fd00000\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/payment-gateways/pre-debit-notification")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"invoiceKey\": \"c2289d0a8d3af0f2018d3b2b1fd00000\",\n  \"paymentGatewayId\": \"80289d0a8d3af0f2018d3b1b8b800000\",\n  \"paymentMethodId\": \"40289d0a8d3af0f2018d3b2b1fd00000\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/v1/payment-gateways/pre-debit-notification")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"invoiceKey\": \"c2289d0a8d3af0f2018d3b2b1fd00000\",\n  \"paymentGatewayId\": \"80289d0a8d3af0f2018d3b1b8b800000\",\n  \"paymentMethodId\": \"40289d0a8d3af0f2018d3b2b1fd00000\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/v1/payment-gateways/pre-debit-notification', [
  'body' => '{
  "invoiceKey": "c2289d0a8d3af0f2018d3b2b1fd00000",
  "paymentGatewayId": "80289d0a8d3af0f2018d3b1b8b800000",
  "paymentMethodId": "40289d0a8d3af0f2018d3b2b1fd00000"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/payment-gateways/pre-debit-notification");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"invoiceKey\": \"c2289d0a8d3af0f2018d3b2b1fd00000\",\n  \"paymentGatewayId\": \"80289d0a8d3af0f2018d3b1b8b800000\",\n  \"paymentMethodId\": \"40289d0a8d3af0f2018d3b2b1fd00000\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "invoiceKey": "c2289d0a8d3af0f2018d3b2b1fd00000",
  "paymentGatewayId": "80289d0a8d3af0f2018d3b1b8b800000",
  "paymentMethodId": "40289d0a8d3af0f2018d3b2b1fd00000"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/payment-gateways/pre-debit-notification")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```